diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-fcm-fm.cc
--- a/libinterp/operators/op-fcm-fm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-fcm-fm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -58,9 +58,9 @@
 DEFBINOP (mul_trans, float_complex_matrix, float_matrix)
 {
   const octave_float_complex_matrix& v1
-    = dynamic_cast<const octave_float_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a1);
   const octave_float_matrix& v2
-    = dynamic_cast<const octave_float_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_matrix&> (a2);
 
   FloatComplexMatrix m1 = v1.float_complex_matrix_value ();
   FloatMatrix m2 = v2.float_matrix_value ();
@@ -72,9 +72,9 @@
 DEFBINOP (div, float_complex_matrix, float_matrix)
 {
   const octave_float_complex_matrix& v1
-    = dynamic_cast<const octave_float_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a1);
   const octave_float_matrix& v2
-    = dynamic_cast<const octave_float_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_matrix&> (a2);
   MatrixType typ = v2.matrix_type ();
 
   FloatComplexMatrix ret = xdiv (v1.float_complex_matrix_value (),
@@ -92,9 +92,9 @@
 DEFBINOP (ldiv, float_complex_matrix, float_matrix)
 {
   const octave_float_complex_matrix& v1
-    = dynamic_cast<const octave_float_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a1);
   const octave_float_matrix& v2
-    = dynamic_cast<const octave_float_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_matrix&> (a2);
   MatrixType typ = v1.matrix_type ();
 
   FloatComplexMatrix ret = xleftdiv (v1.float_complex_matrix_value (),
@@ -127,9 +127,9 @@
 DEFBINOP (el_ldiv, float_complex_matrix, float_matrix)
 {
   const octave_float_complex_matrix& v1
-    = dynamic_cast<const octave_float_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a1);
   const octave_float_matrix& v2
-    = dynamic_cast<const octave_float_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_matrix&> (a2);
 
   return quotient (v2.float_array_value (), v1.float_complex_array_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-fcm-fs.cc
--- a/libinterp/operators/op-fcm-fs.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-fcm-fs.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -55,9 +55,9 @@
 DEFBINOP (div, float_complex_matrix, float)
 {
   const octave_float_complex_matrix& v1
-    = dynamic_cast<const octave_float_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a1);
   const octave_float_scalar& v2
-    = dynamic_cast<const octave_float_scalar&> (a2);
+    = DYNORSTAT_CAST<const octave_float_scalar&> (a2);
 
   return octave_value (v1.float_complex_array_value () / v2.float_value ());
 }
@@ -67,9 +67,9 @@
 DEFBINOP (ldiv, float_complex_matrix, float)
 {
   const octave_float_complex_matrix& v1
-    = dynamic_cast<const octave_float_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a1);
   const octave_float_scalar& v2
-    = dynamic_cast<const octave_float_scalar&> (a2);
+    = DYNORSTAT_CAST<const octave_float_scalar&> (a2);
 
   FloatComplexMatrix m1 = v1.float_complex_matrix_value ();
   FloatMatrix m2 = v2.float_matrix_value ();
@@ -100,9 +100,9 @@
 DEFBINOP (el_div, float_complex_matrix, float)
 {
   const octave_float_complex_matrix& v1
-    = dynamic_cast<const octave_float_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a1);
   const octave_float_scalar& v2
-    = dynamic_cast<const octave_float_scalar&> (a2);
+    = DYNORSTAT_CAST<const octave_float_scalar&> (a2);
 
   return octave_value (v1.float_complex_array_value () / v2.float_value ());
 }
@@ -113,9 +113,9 @@
 DEFBINOP (el_ldiv, float_complex_matrix, float)
 {
   const octave_float_complex_matrix& v1
-    = dynamic_cast<const octave_float_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a1);
   const octave_float_scalar& v2
-    = dynamic_cast<const octave_float_scalar&> (a2);
+    = DYNORSTAT_CAST<const octave_float_scalar&> (a2);
 
   return elem_xdiv (v2.float_value (), v1.float_complex_array_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-fcn.cc
--- a/libinterp/operators/op-fcn.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-fcn.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -39,16 +39,16 @@
 
 DEFBINOP (eq, fcn_handle, fcn_handle)
 {
-  const octave_fcn_handle& v1 = dynamic_cast<const octave_fcn_handle&> (a1);
-  const octave_fcn_handle& v2 = dynamic_cast<const octave_fcn_handle&> (a2);
+  const octave_fcn_handle& v1 = DYNORSTAT_CAST<const octave_fcn_handle&> (a1);
+  const octave_fcn_handle& v2 = DYNORSTAT_CAST<const octave_fcn_handle&> (a2);
 
   return is_equal_to (v1, v2);
 }
 
 DEFBINOP (ne, fcn_handle, fcn_handle)
 {
-  const octave_fcn_handle& v1 = dynamic_cast<const octave_fcn_handle&> (a1);
-  const octave_fcn_handle& v2 = dynamic_cast<const octave_fcn_handle&> (a2);
+  const octave_fcn_handle& v1 = DYNORSTAT_CAST<const octave_fcn_handle&> (a1);
+  const octave_fcn_handle& v2 = DYNORSTAT_CAST<const octave_fcn_handle&> (a2);
 
   return ! is_equal_to (v1, v2);
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-fcs-fcm.cc
--- a/libinterp/operators/op-fcs-fcm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-fcs-fcm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -52,9 +52,9 @@
 DEFBINOP (div, float_complex, float_complex_matrix)
 {
   const octave_float_complex& v1
-    = dynamic_cast<const octave_float_complex&> (a1);
+    = DYNORSTAT_CAST<const octave_float_complex&> (a1);
   const octave_float_complex_matrix& v2
-    = dynamic_cast<const octave_float_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a2);
 
   FloatComplexMatrix m1 = v1.float_complex_matrix_value ();
   FloatComplexMatrix m2 = v2.float_complex_matrix_value ();
@@ -71,9 +71,9 @@
 DEFBINOP (ldiv, float_complex, float_complex_matrix)
 {
   const octave_float_complex& v1
-    = dynamic_cast<const octave_float_complex&> (a1);
+    = DYNORSTAT_CAST<const octave_float_complex&> (a1);
   const octave_float_complex_matrix& v2
-    = dynamic_cast<const octave_float_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a2);
 
   return octave_value (v2.float_complex_array_value () / v1.float_complex_value ());
 }
@@ -101,9 +101,9 @@
 DEFBINOP (el_ldiv, float_complex, float_complex_matrix)
 {
   const octave_float_complex& v1
-    = dynamic_cast<const octave_float_complex&> (a1);
+    = DYNORSTAT_CAST<const octave_float_complex&> (a1);
   const octave_float_complex_matrix& v2
-    = dynamic_cast<const octave_float_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a2);
 
   return octave_value (v2.float_complex_array_value () / v1.float_complex_value ());
 }
@@ -125,7 +125,7 @@
 DEFCONV (float_complex_matrix_conv, float_complex, float_complex_matrix)
 {
   const octave_float_complex& v
-    = dynamic_cast<const octave_float_complex&> (a);
+    = DYNORSTAT_CAST<const octave_float_complex&> (a);
 
   return new octave_float_complex_matrix (v.float_complex_matrix_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-fcs-fcs.cc
--- a/libinterp/operators/op-fcs-fcs.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-fcs-fcs.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -44,7 +44,7 @@
 
 DEFUNOP (not, float_complex)
 {
-  const octave_float_complex& v = dynamic_cast<const octave_float_complex&> (a);
+  const octave_float_complex& v = DYNORSTAT_CAST<const octave_float_complex&> (a);
   FloatComplex x = v.float_complex_value ();
   if (octave::math::isnan (x))
     octave::err_nan_to_logical_conversion ();
@@ -58,7 +58,7 @@
 
 DEFUNOP (hermitian, float_complex)
 {
-  const octave_float_complex& v = dynamic_cast<const octave_float_complex&> (a);
+  const octave_float_complex& v = DYNORSTAT_CAST<const octave_float_complex&> (a);
 
   return octave_value (conj (v.float_complex_value ()));
 }
@@ -74,8 +74,8 @@
 
 DEFBINOP (div, float_complex, float_complex)
 {
-  const octave_float_complex& v1 = dynamic_cast<const octave_float_complex&> (a1);
-  const octave_float_complex& v2 = dynamic_cast<const octave_float_complex&> (a2);
+  const octave_float_complex& v1 = DYNORSTAT_CAST<const octave_float_complex&> (a1);
+  const octave_float_complex& v2 = DYNORSTAT_CAST<const octave_float_complex&> (a2);
 
   return octave_value (v1.float_complex_value () / v2.float_complex_value ());
 }
@@ -84,8 +84,8 @@
 
 DEFBINOP (ldiv, float_complex, float_complex)
 {
-  const octave_float_complex& v1 = dynamic_cast<const octave_float_complex&> (a1);
-  const octave_float_complex& v2 = dynamic_cast<const octave_float_complex&> (a2);
+  const octave_float_complex& v1 = DYNORSTAT_CAST<const octave_float_complex&> (a1);
+  const octave_float_complex& v2 = DYNORSTAT_CAST<const octave_float_complex&> (a2);
 
   return octave_value (v2.float_complex_value () / v1.float_complex_value ());
 }
@@ -101,8 +101,8 @@
 
 DEFBINOP (el_div, float_complex, float_complex)
 {
-  const octave_float_complex& v1 = dynamic_cast<const octave_float_complex&> (a1);
-  const octave_float_complex& v2 = dynamic_cast<const octave_float_complex&> (a2);
+  const octave_float_complex& v1 = DYNORSTAT_CAST<const octave_float_complex&> (a1);
+  const octave_float_complex& v2 = DYNORSTAT_CAST<const octave_float_complex&> (a2);
 
   return octave_value (v1.float_complex_value () / v2.float_complex_value ());
 }
@@ -111,16 +111,16 @@
 
 DEFBINOP (el_ldiv, float_complex, float_complex)
 {
-  const octave_float_complex& v1 = dynamic_cast<const octave_float_complex&> (a1);
-  const octave_float_complex& v2 = dynamic_cast<const octave_float_complex&> (a2);
+  const octave_float_complex& v1 = DYNORSTAT_CAST<const octave_float_complex&> (a1);
+  const octave_float_complex& v2 = DYNORSTAT_CAST<const octave_float_complex&> (a2);
 
   return octave_value (v2.float_complex_value () / v1.float_complex_value ());
 }
 
 DEFBINOP (el_and, float_complex, float_complex)
 {
-  const octave_float_complex& v1 = dynamic_cast<const octave_float_complex&> (a1);
-  const octave_float_complex& v2 = dynamic_cast<const octave_float_complex&> (a2);
+  const octave_float_complex& v1 = DYNORSTAT_CAST<const octave_float_complex&> (a1);
+  const octave_float_complex& v2 = DYNORSTAT_CAST<const octave_float_complex&> (a2);
 
   return (v1.float_complex_value () != 0.0f
           && v2.float_complex_value () != 0.0f);
@@ -128,8 +128,8 @@
 
 DEFBINOP (el_or, float_complex, float_complex)
 {
-  const octave_float_complex& v1 = dynamic_cast<const octave_float_complex&> (a1);
-  const octave_float_complex& v2 = dynamic_cast<const octave_float_complex&> (a2);
+  const octave_float_complex& v1 = DYNORSTAT_CAST<const octave_float_complex&> (a1);
+  const octave_float_complex& v2 = DYNORSTAT_CAST<const octave_float_complex&> (a2);
 
   return (v1.float_complex_value () != 0.0f
           || v2.float_complex_value () != 0.0f);
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-fcs-fm.cc
--- a/libinterp/operators/op-fcs-fm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-fcs-fm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -53,8 +53,8 @@
 
 DEFBINOP (div, float_complex, float_matrix)
 {
-  const octave_float_complex& v1 = dynamic_cast<const octave_float_complex&> (a1);
-  const octave_float_matrix& v2 = dynamic_cast<const octave_float_matrix&> (a2);
+  const octave_float_complex& v1 = DYNORSTAT_CAST<const octave_float_complex&> (a1);
+  const octave_float_matrix& v2 = DYNORSTAT_CAST<const octave_float_matrix&> (a2);
 
   FloatComplexMatrix m1 = v1.float_complex_matrix_value ();
   FloatMatrix m2 = v2.float_matrix_value ();
@@ -70,8 +70,8 @@
 
 DEFBINOP (ldiv, float_complex, float_matrix)
 {
-  const octave_float_complex& v1 = dynamic_cast<const octave_float_complex&> (a1);
-  const octave_float_matrix& v2 = dynamic_cast<const octave_float_matrix&> (a2);
+  const octave_float_complex& v1 = DYNORSTAT_CAST<const octave_float_complex&> (a1);
+  const octave_float_matrix& v2 = DYNORSTAT_CAST<const octave_float_matrix&> (a2);
 
   return octave_value (v2.float_array_value () / v1.float_complex_value ());
 }
@@ -98,8 +98,8 @@
 
 DEFBINOP (el_ldiv, float_complex, float_matrix)
 {
-  const octave_float_complex& v1 = dynamic_cast<const octave_float_complex&> (a1);
-  const octave_float_matrix& v2 = dynamic_cast<const octave_float_matrix&> (a2);
+  const octave_float_complex& v1 = DYNORSTAT_CAST<const octave_float_complex&> (a1);
+  const octave_float_matrix& v2 = DYNORSTAT_CAST<const octave_float_matrix&> (a2);
 
   return octave_value (v2.float_array_value () / v1.float_complex_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-fcs-fs.cc
--- a/libinterp/operators/op-fcs-fs.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-fcs-fs.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -50,8 +50,8 @@
 
 DEFBINOP (div, float_complex, float)
 {
-  const octave_float_complex& v1 = dynamic_cast<const octave_float_complex&> (a1);
-  const octave_float_scalar& v2 = dynamic_cast<const octave_float_scalar&> (a2);
+  const octave_float_complex& v1 = DYNORSTAT_CAST<const octave_float_complex&> (a1);
+  const octave_float_scalar& v2 = DYNORSTAT_CAST<const octave_float_scalar&> (a2);
 
   return octave_value (v1.float_complex_value () / v2.float_value ());
 }
@@ -60,8 +60,8 @@
 
 DEFBINOP (ldiv, float_complex, float)
 {
-  const octave_float_complex& v1 = dynamic_cast<const octave_float_complex&> (a1);
-  const octave_float_scalar& v2 = dynamic_cast<const octave_float_scalar&> (a2);
+  const octave_float_complex& v1 = DYNORSTAT_CAST<const octave_float_complex&> (a1);
+  const octave_float_scalar& v2 = DYNORSTAT_CAST<const octave_float_scalar&> (a2);
 
   return octave_value (v2.float_value () / v1.float_complex_value ());
 }
@@ -77,8 +77,8 @@
 
 DEFBINOP (el_div, float_complex, float)
 {
-  const octave_float_complex& v1 = dynamic_cast<const octave_float_complex&> (a1);
-  const octave_float_scalar& v2 = dynamic_cast<const octave_float_scalar&> (a2);
+  const octave_float_complex& v1 = DYNORSTAT_CAST<const octave_float_complex&> (a1);
+  const octave_float_scalar& v2 = DYNORSTAT_CAST<const octave_float_scalar&> (a2);
 
   return octave_value (v1.float_complex_value () / v2.float_value ());
 }
@@ -87,24 +87,24 @@
 
 DEFBINOP (el_ldiv, float_complex, float)
 {
-  const octave_float_complex& v1 = dynamic_cast<const octave_float_complex&> (a1);
-  const octave_float_scalar& v2 = dynamic_cast<const octave_float_scalar&> (a2);
+  const octave_float_complex& v1 = DYNORSTAT_CAST<const octave_float_complex&> (a1);
+  const octave_float_scalar& v2 = DYNORSTAT_CAST<const octave_float_scalar&> (a2);
 
   return octave_value (v2.float_value () / v1.float_complex_value ());
 }
 
 DEFBINOP (el_and, float_complex, float)
 {
-  const octave_float_complex& v1 = dynamic_cast<const octave_float_complex&> (a1);
-  const octave_float_scalar& v2 = dynamic_cast<const octave_float_scalar&> (a2);
+  const octave_float_complex& v1 = DYNORSTAT_CAST<const octave_float_complex&> (a1);
+  const octave_float_scalar& v2 = DYNORSTAT_CAST<const octave_float_scalar&> (a2);
 
   return (v1.float_complex_value () != 0.0f && v2.float_value ());
 }
 
 DEFBINOP (el_or, float_complex, float)
 {
-  const octave_float_complex& v1 = dynamic_cast<const octave_float_complex&> (a1);
-  const octave_float_scalar& v2 = dynamic_cast<const octave_float_scalar&> (a2);
+  const octave_float_complex& v1 = DYNORSTAT_CAST<const octave_float_complex&> (a1);
+  const octave_float_scalar& v2 = DYNORSTAT_CAST<const octave_float_scalar&> (a2);
 
   return (v1.float_complex_value () != 0.0f || v2.float_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-fdm-fdm.cc
--- a/libinterp/operators/op-fdm-fdm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-fdm-fdm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -48,7 +48,7 @@
 DEFUNOP (transpose, float_diag_matrix)
 {
   const octave_float_diag_matrix& v
-    = dynamic_cast<const octave_float_diag_matrix&> (a);
+    = DYNORSTAT_CAST<const octave_float_diag_matrix&> (a);
   return octave_value (v.float_diag_matrix_value ().transpose ());
 }
 
@@ -61,9 +61,9 @@
 DEFBINOP (div, float_diag_matrix, float_diag_matrix)
 {
   const octave_float_diag_matrix& v1
-    = dynamic_cast<const octave_float_diag_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_float_diag_matrix&> (a1);
   const octave_float_diag_matrix& v2
-    = dynamic_cast<const octave_float_diag_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_diag_matrix&> (a2);
 
   return xdiv (v1.float_diag_matrix_value (),
                v2.float_diag_matrix_value ());
@@ -72,9 +72,9 @@
 DEFBINOP (ldiv, float_diag_matrix, float_diag_matrix)
 {
   const octave_float_diag_matrix& v1
-    = dynamic_cast<const octave_float_diag_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_float_diag_matrix&> (a1);
   const octave_float_diag_matrix& v2
-    = dynamic_cast<const octave_float_diag_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_diag_matrix&> (a2);
 
   return xleftdiv (v1.float_diag_matrix_value (),
                    v2.float_diag_matrix_value ());
@@ -83,7 +83,7 @@
 CONVDECL (float_diag_matrix_to_float_matrix)
 {
   const octave_float_diag_matrix& v
-    = dynamic_cast<const octave_float_diag_matrix&> (a);
+    = DYNORSTAT_CAST<const octave_float_diag_matrix&> (a);
 
   return new octave_float_matrix (v.float_matrix_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-fm-fcm.cc
--- a/libinterp/operators/op-fm-fcm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-fm-fcm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -58,9 +58,9 @@
 DEFBINOP (trans_mul, float_matrix, float_complex_matrix)
 {
   const octave_float_matrix& v1
-    = dynamic_cast<const octave_float_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
   const octave_float_complex_matrix& v2
-    = dynamic_cast<const octave_float_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a2);
 
   FloatMatrix m1 = v1.float_matrix_value ();
   FloatComplexMatrix m2 = v2.float_complex_matrix_value ();
@@ -72,9 +72,9 @@
 DEFBINOP (div, float_matrix, float_complex_matrix)
 {
   const octave_float_matrix& v1
-    = dynamic_cast<const octave_float_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
   const octave_float_complex_matrix& v2
-    = dynamic_cast<const octave_float_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a2);
   MatrixType typ = v2.matrix_type ();
 
   FloatComplexMatrix ret = xdiv (v1.float_matrix_value (),
@@ -92,9 +92,9 @@
 DEFBINOP (ldiv, float_matrix, float_complex_matrix)
 {
   const octave_float_matrix& v1
-    = dynamic_cast<const octave_float_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
   const octave_float_complex_matrix& v2
-    = dynamic_cast<const octave_float_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a2);
   MatrixType typ = v1.matrix_type ();
 
   FloatComplexMatrix ret = xleftdiv (v1.float_matrix_value (),
@@ -107,9 +107,9 @@
 DEFBINOP (trans_ldiv, float_matrix, float_complex_matrix)
 {
   const octave_float_matrix& v1
-    = dynamic_cast<const octave_float_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
   const octave_float_complex_matrix& v2
-    = dynamic_cast<const octave_float_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a2);
   MatrixType typ = v1.matrix_type ();
 
   FloatComplexMatrix ret = xleftdiv (v1.float_matrix_value (),
@@ -143,9 +143,9 @@
 DEFBINOP (el_ldiv, float_matrix, float_complex_matrix)
 {
   const octave_float_matrix& v1
-    = dynamic_cast<const octave_float_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
   const octave_float_complex_matrix& v2
-    = dynamic_cast<const octave_float_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a2);
 
   return quotient (v2.float_complex_array_value (), v1.float_array_value ());
 }
@@ -166,7 +166,7 @@
 
 DEFCONV (float_complex_matrix_conv, float_matrix, float_complex_matrix)
 {
-  const octave_float_matrix& v = dynamic_cast<const octave_float_matrix&> (a);
+  const octave_float_matrix& v = DYNORSTAT_CAST<const octave_float_matrix&> (a);
 
   return new octave_float_complex_matrix (FloatComplexNDArray
                                            (v.float_array_value ()));
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-fm-fcs.cc
--- a/libinterp/operators/op-fm-fcs.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-fm-fcs.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -55,8 +55,8 @@
 
 DEFBINOP (div, float_matrix, float_complex)
 {
-  const octave_float_matrix& v1 = dynamic_cast<const octave_float_matrix&> (a1);
-  const octave_float_complex& v2 = dynamic_cast<const octave_float_complex&> (a2);
+  const octave_float_matrix& v1 = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
+  const octave_float_complex& v2 = DYNORSTAT_CAST<const octave_float_complex&> (a2);
 
   return octave_value (v1.float_array_value () / v2.float_complex_value ());
 }
@@ -65,8 +65,8 @@
 
 DEFBINOP (ldiv, float_matrix, float_complex)
 {
-  const octave_float_matrix& v1 = dynamic_cast<const octave_float_matrix&> (a1);
-  const octave_float_complex& v2 = dynamic_cast<const octave_float_complex&> (a2);
+  const octave_float_matrix& v1 = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
+  const octave_float_complex& v2 = DYNORSTAT_CAST<const octave_float_complex&> (a2);
 
   FloatMatrix m1 = v1.float_matrix_value ();
   FloatComplexMatrix m2 = v2.float_complex_matrix_value ();
@@ -96,8 +96,8 @@
 
 DEFBINOP (el_div, float_matrix, float_complex)
 {
-  const octave_float_matrix& v1 = dynamic_cast<const octave_float_matrix&> (a1);
-  const octave_float_complex& v2 = dynamic_cast<const octave_float_complex&> (a2);
+  const octave_float_matrix& v1 = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
+  const octave_float_complex& v2 = DYNORSTAT_CAST<const octave_float_complex&> (a2);
 
   return octave_value (v1.float_array_value () / v2.float_complex_value ());
 }
@@ -107,8 +107,8 @@
 
 DEFBINOP (el_ldiv, float_matrix, flaot_complex)
 {
-  const octave_float_matrix& v1 = dynamic_cast<const octave_float_matrix&> (a1);
-  const octave_float_complex& v2 = dynamic_cast<const octave_float_complex&> (a2);
+  const octave_float_matrix& v1 = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
+  const octave_float_complex& v2 = DYNORSTAT_CAST<const octave_float_complex&> (a2);
 
   return elem_xdiv (v2.float_complex_value (), v1.float_array_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-fm-fm.cc
--- a/libinterp/operators/op-fm-fm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-fm-fm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -48,7 +48,7 @@
 
 DEFUNOP (transpose, float_matrix)
 {
-  const octave_float_matrix& v = dynamic_cast<const octave_float_matrix&> (a);
+  const octave_float_matrix& v = DYNORSTAT_CAST<const octave_float_matrix&> (a);
 
   if (v.ndims () > 2)
     error ("transpose not defined for N-D objects");
@@ -69,8 +69,8 @@
 
 DEFBINOP (div, float_matrix, float_matrix)
 {
-  const octave_float_matrix& v1 = dynamic_cast<const octave_float_matrix&> (a1);
-  const octave_float_matrix& v2 = dynamic_cast<const octave_float_matrix&> (a2);
+  const octave_float_matrix& v1 = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
+  const octave_float_matrix& v2 = DYNORSTAT_CAST<const octave_float_matrix&> (a2);
   MatrixType typ = v2.matrix_type ();
 
   FloatMatrix ret = xdiv (v1.float_matrix_value (),
@@ -87,8 +87,8 @@
 
 DEFBINOP (ldiv, float_matrix, float_matrix)
 {
-  const octave_float_matrix& v1 = dynamic_cast<const octave_float_matrix&> (a1);
-  const octave_float_matrix& v2 = dynamic_cast<const octave_float_matrix&> (a2);
+  const octave_float_matrix& v1 = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
+  const octave_float_matrix& v2 = DYNORSTAT_CAST<const octave_float_matrix&> (a2);
   MatrixType typ = v1.matrix_type ();
 
   FloatMatrix ret = xleftdiv (v1.float_matrix_value (),
@@ -100,8 +100,8 @@
 
 DEFBINOP (trans_mul, float_matrix, float_matrix)
 {
-  const octave_float_matrix& v1 = dynamic_cast<const octave_float_matrix&> (a1);
-  const octave_float_matrix& v2 = dynamic_cast<const octave_float_matrix&> (a2);
+  const octave_float_matrix& v1 = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
+  const octave_float_matrix& v2 = DYNORSTAT_CAST<const octave_float_matrix&> (a2);
   return octave_value(xgemm (v1.float_matrix_value (),
                              v2.float_matrix_value (),
                              blas_trans, blas_no_trans));
@@ -109,8 +109,8 @@
 
 DEFBINOP (mul_trans, float_matrix, float_matrix)
 {
-  const octave_float_matrix& v1 = dynamic_cast<const octave_float_matrix&> (a1);
-  const octave_float_matrix& v2 = dynamic_cast<const octave_float_matrix&> (a2);
+  const octave_float_matrix& v1 = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
+  const octave_float_matrix& v2 = DYNORSTAT_CAST<const octave_float_matrix&> (a2);
   return octave_value(xgemm (v1.float_matrix_value (),
                              v2.float_matrix_value (),
                              blas_no_trans, blas_trans));
@@ -118,8 +118,8 @@
 
 DEFBINOP (trans_ldiv, float_matrix, float_matrix)
 {
-  const octave_float_matrix& v1 = dynamic_cast<const octave_float_matrix&> (a1);
-  const octave_float_matrix& v2 = dynamic_cast<const octave_float_matrix&> (a2);
+  const octave_float_matrix& v1 = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
+  const octave_float_matrix& v2 = DYNORSTAT_CAST<const octave_float_matrix&> (a2);
   MatrixType typ = v1.matrix_type ();
 
   FloatMatrix ret = xleftdiv (v1.float_matrix_value (),
@@ -151,8 +151,8 @@
 
 DEFBINOP (el_ldiv, float_matrix, float_matrix)
 {
-  const octave_float_matrix& v1 = dynamic_cast<const octave_float_matrix&> (a1);
-  const octave_float_matrix& v2 = dynamic_cast<const octave_float_matrix&> (a2);
+  const octave_float_matrix& v1 = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
+  const octave_float_matrix& v2 = DYNORSTAT_CAST<const octave_float_matrix&> (a2);
 
   return octave_value (quotient (v2.float_array_value (),
                                  v1.float_array_value ()));
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-fm-fs.cc
--- a/libinterp/operators/op-fm-fs.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-fm-fs.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -47,8 +47,8 @@
 
 DEFBINOP (div, float_matrix, float)
 {
-  const octave_float_matrix& v1 = dynamic_cast<const octave_float_matrix&> (a1);
-  const octave_float_scalar& v2 = dynamic_cast<const octave_float_scalar&> (a2);
+  const octave_float_matrix& v1 = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
+  const octave_float_scalar& v2 = DYNORSTAT_CAST<const octave_float_scalar&> (a2);
 
   return octave_value (v1.float_array_value () / v2.float_value ());
 }
@@ -57,8 +57,8 @@
 
 DEFBINOP (ldiv, float_matrix, float)
 {
-  const octave_float_matrix& v1 = dynamic_cast<const octave_float_matrix&> (a1);
-  const octave_float_scalar& v2 = dynamic_cast<const octave_float_scalar&> (a2);
+  const octave_float_matrix& v1 = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
+  const octave_float_scalar& v2 = DYNORSTAT_CAST<const octave_float_scalar&> (a2);
 
   FloatMatrix m1 = v1.float_matrix_value ();
   FloatMatrix m2 = v2.float_matrix_value ();
@@ -87,8 +87,8 @@
 
 DEFBINOP (el_div, float_matrix, float)
 {
-  const octave_float_matrix& v1 = dynamic_cast<const octave_float_matrix&> (a1);
-  const octave_float_scalar& v2 = dynamic_cast<const octave_float_scalar&> (a2);
+  const octave_float_matrix& v1 = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
+  const octave_float_scalar& v2 = DYNORSTAT_CAST<const octave_float_scalar&> (a2);
 
   return octave_value (v1.float_array_value () / v2.float_value ());
 }
@@ -98,8 +98,8 @@
 
 DEFBINOP (el_ldiv, float_matrix, float)
 {
-  const octave_float_matrix& v1 = dynamic_cast<const octave_float_matrix&> (a1);
-  const octave_float_scalar& v2 = dynamic_cast<const octave_float_scalar&> (a2);
+  const octave_float_matrix& v1 = DYNORSTAT_CAST<const octave_float_matrix&> (a1);
+  const octave_float_scalar& v2 = DYNORSTAT_CAST<const octave_float_scalar&> (a2);
 
   return elem_xdiv (v2.float_value (), v1.float_array_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-fs-fcm.cc
--- a/libinterp/operators/op-fs-fcm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-fs-fcm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -58,9 +58,9 @@
 DEFBINOP (div, float_scalar, float_complex_matrix)
 {
   const octave_float_scalar& v1
-    = dynamic_cast<const octave_float_scalar&> (a1);
+    = DYNORSTAT_CAST<const octave_float_scalar&> (a1);
   const octave_float_complex_matrix& v2
-    = dynamic_cast<const octave_float_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a2);
 
   FloatMatrix m1 = v1.float_matrix_value ();
   FloatComplexMatrix m2 = v2.float_complex_matrix_value ();
@@ -77,9 +77,9 @@
 DEFBINOP (ldiv, float_scalar, float_complex_matrix)
 {
   const octave_float_scalar& v1
-    = dynamic_cast<const octave_float_scalar&> (a1);
+    = DYNORSTAT_CAST<const octave_float_scalar&> (a1);
   const octave_float_complex_matrix& v2
-    = dynamic_cast<const octave_float_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a2);
 
   return octave_value (v2.float_complex_array_value () / v1.float_value ());
 }
@@ -107,9 +107,9 @@
 DEFBINOP (el_ldiv, float_scalar, float_complex_matrix)
 {
   const octave_float_scalar& v1
-    = dynamic_cast<const octave_float_scalar&> (a1);
+    = DYNORSTAT_CAST<const octave_float_scalar&> (a1);
   const octave_float_complex_matrix& v2
-    = dynamic_cast<const octave_float_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_float_complex_matrix&> (a2);
 
   return octave_value (v2.float_complex_array_value () / v1.float_value ());
 }
@@ -130,7 +130,7 @@
 
 DEFCONV (float_complex_matrix_conv, float_scalar, float_complex_matrix)
 {
-  const octave_float_scalar& v = dynamic_cast<const octave_float_scalar&> (a);
+  const octave_float_scalar& v = DYNORSTAT_CAST<const octave_float_scalar&> (a);
 
   return new octave_float_complex_matrix (FloatComplexMatrix
                                             (v.float_matrix_value ()));
